// binloud.h

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <string.h>
#include "nrutil.h"


#define N_COMP						5000  // maximum number of spectral components
#define MAX_THR						100  // max points in correction file

#define C1								24.673
#define C2								4.368
#define C3  							(2302.6/(C1 * C2))

#define p51_1k						(4.0 * 1000.0/(C1 * ( C2 + 1.0)))
#define TRUE							1
#define FALSE							0
#define ESTART						1.8
#define EEND							38.9
#define ESTEP							0.1
#define N_ERBS						(long)((EEND - ESTART)/ESTEP + 1.5) // = 372

double ex_table(double frqHz);
double Btable(double alpha);
double alpha100(double G_dB);	
double alpha90(double G_dB);
double lin_int(double *yy,double *xx, double x, unsigned long n);
double erbtofq(double E);
double so2phons(double sones);
double calc_K(double freqkHz);
double Shaw_cor(double frqHz);
double Zwicker_cor(double frqHz);
double mid_corr(double frqHz);
double diff_cor(double frqHz);
double thr_corr(double frqhz, long n_thr, double *corr_hz, double *corr_dB);
int  getopt(int argc, char *argv[], char *optionS);
void info(void);
void get_n_doubles(double *bufin, long npts);
//void clrscr(void);
void read_corr(long *n_corr, double *corr_Hz, double *corr_dB, FILE *corr_fd);

void input   ( double *compfq, double *compdB, long *ncomps);
void tone    ( double *compfq, double *compdB, long *ncomps);
void choosen ( double *compfq, double *compdB, long *ncomps);
void white_noise( double *compfq, double *compdB, long *ncomps);
void pink_noise( double *compfq, double *compdB, long *ncomps);
void uen_noise( double *compfq, double *compdB, long *ncomps);
void ten_noise( double *compfq, double *compdB, long *ncomps);
void sortfq  ( double *compfq, double *compdb, long ncomps);
void getdouble(double *fl);
void error(long ncomps);
void getlong(long *in);
void locate(double *xx, long n, double x, long *j); /*  Numerical Recipes  page 98 */
void polint(double *xa, double *ya, long n, double x, double *y, double *dy);   /* Numerical Recipes  p90 */
void third(double *compfq, double *compdB, long *ncomps);
void getdoubles(double *bufin, long npts);
void silent_channel( double *compfq, double *compdB, long *ncomps);



extern short questions, prt;
extern char str[128];
