// loud_aesSUB.c

#include "binloud.h"

extern int channel;

// global to this file
long w_chosen, p_chosen, t_chosen;

//-------------------------------------------------------------------------------

// This is the subroutine for getting the frequencies and levels of the components.
  void input(double* compfq, double* compdB, long *ncomps)
{
char char1;

  w_chosen=FALSE, p_chosen=FALSE, t_chosen=FALSE; // set for chan 1 & reset for channel 2
label:  // don't tell anyone I've used a label loop
  do {
    if(questions)fprintf(stderr," Complex Tone[t], Noiseband[n], Mixed[m] Signal, Third octaves[o], silence [s] or finish [f] ? ");
		gets(str); sscanf(str,"%c",&char1);
  } while(char1 != 't' && char1 != 'n' && char1 != 'm' && char1 != 'o' && char1 != 's' && char1 != 'f');

  *ncomps = 0;
  if(char1 == 't' || char1 == 'm') tone(compfq,compdB,ncomps);
  if(char1 == 'n' || char1 == 'm') choosen(compfq,compdB,ncomps);
	if(char1 == 'o' ) third(compfq,compdB,ncomps);
  if(char1 == 's' ) silent_channel(compfq,compdB,ncomps);

  if(char1 == 'f')             // input finished
    if(channel == 1) exit(0);  // or when asking for channel 1 input it can exit
    else {
    printf("\n\nNeed some input for channel 2   (use CTRL C to abort program)\n\n");
    goto label;
  }

/* Sort the freqs and associated dB values into ascending freq order*/
	sortfq(compfq,compdB,*ncomps);
}
/*-------------------------------------------------------------*/
void silent_channel( double *compfq, double *compdB, long *ncomps)
{
  *ncomps += 1;
  compfq[*ncomps] = 100.0;   // for a silent channel use 100 Hz at -100 dB
  compdB[*ncomps] = -100.0;
}
/*-------------------------------------------------------------*/
void tone( double *compfq, double *compdB, long *ncomps)

/* Request the fundamental frequency of the periodic sound and the frequencies
* of the first and last harmonics all in Hz. Components may be both removed
* from and added to the harmonic series.  Set up an array, compfq, holding
* the component frequencies, and request the level of each component in dB.*/
{
long i,j,jj,nadd,nrem,itemp;
double addfq[20],remfq[20],first,last,fund;
char char1;

  do{
    if(questions) fprintf(stderr," Harmonic [h] or Inharmonic [i] Complex Tone ?\n");
		gets(str); sscanf(str,"%c",&char1);
    }while(char1 != 'h' && char1 != 'i');

  if(char1 == 'h') {
    if(questions) fprintf(stderr," First Harm.,  Last Harm.,   Fund  [Hz] (comma separated)?\n");
		gets(str); sscanf(str,"%lf ,%lf ,%lf",&first,&last,&fund);
    if( (first < 0.1) || (last < 0.1) || (fund < 0.1 )){
      fprintf(stderr,"\n\nNeed numbers for First Harm.,  Last Harm. & Fund  [Hz]\n\n");
      exit(0);
    }
    *ncomps = (long)((last - first)/fund + 1.5);
    if(*ncomps >= N_COMP) error(*ncomps);
    for( i = 1; i <= *ncomps ; i++) compfq[i] = first + (i-1) * fund;
    do{
      if(questions) fprintf(stderr," No. of Components to be Removed [0-20] ?\n");
      getlong(&nrem);
    } while(nrem > 20);
    if(nrem > 0) {
      for( i = 1; i <= nrem ; i++){
        if(questions) fprintf(stderr," Removed Freq. %d :\n",i);
				gets(str); sscanf(str,"%lf",&remfq[i]);
        if(remfq[i] < 0.1){
          fprintf(stderr,"Need a number for Removed Freq %d\n",i);
          exit(0);
        }
      }

      itemp = *ncomps;
      jj = 0;
      for (j = 1 ; j <= *ncomps ; j++){   /* scan over freqs */
        jj++;
        for( i = 1; i <= nrem; i++){      /* scan over harmonics */
          if(remfq[i] == compfq[j]) {
            remfq[i] = -1.0;
            jj++; itemp--;
          }
        }
      *ncomps = itemp;
      compfq[j] = compfq[jj];
      }
    }
    for( i = 1; i <= nrem ; i++)
      if(remfq[i] != -1.0) fprintf(stderr," !! frequency %.1f Hz is not there !!\n",remfq[i]);
  }
  do{
    if(questions) fprintf(stderr," No. of Components to be Added [0-20] ?\n");
    getlong(&nadd);
  }while(nadd > 20);

  if(nadd > 0) {
    for( i = 1; i <= nadd ; i++){
      do{
        if(questions) fprintf(stderr," Added Freq. between 20 and 18000 Hz incl. %d :\n",i);
	  		gets(str); 
        sscanf(str,"%lf",&addfq[i]);
      } while(addfq[i] < 20.0 || addfq[i] > 18000.0);
      *ncomps = *ncomps+1;
      compfq[*ncomps] = addfq[i];
    }
  }
	for( i = 1; i <= *ncomps ; i++){
    if(questions) fprintf(stderr,"  Component Freq. %.1lf [Hz].  Intensity [dB] ?\n",compfq[i]);
    getdouble(&compdB[i]);
  }
}
/*----------------------------------------------------------------*/
void error(long ncomps)
{
  if(ncomps > N_COMP) {
		fprintf(stderr,"Asking for more than the maximum number of components (%ld)\n",N_COMP);
		exit(0);
  }
}
/*----------------------------------------------------------------*/

void choosen( double* compfq, double* compdB,long *ncomps)
{
char noisetype = 'z';

  do{
      if(!p_chosen && !w_chosen && !t_chosen){
        if(questions) fprintf(stderr," Pink(p) or White (w) or Ten (t) Noise, to end noises (e) ? ");
        gets(str); sscanf(str,"%c",&noisetype);
      }

      if( p_chosen && !w_chosen && !t_chosen){
        if(questions) fprintf(stderr," White (w) or Ten (t) noise, to end noises (e) ? ");
        gets(str); sscanf(str,"%c",&noisetype);
      }

      if(!p_chosen &&  w_chosen && !t_chosen){
        if(questions) fprintf(stderr," Pink (p) or Ten (t) noise, to end noises (e) ? ");
        gets(str); sscanf(str,"%c",&noisetype);
      }

      if(!p_chosen && !w_chosen &&  t_chosen){
        if(questions) fprintf(stderr," Pink (p) or White (w) noise, to end noises (e) ? ");
        gets(str); sscanf(str,"%c",&noisetype);
      }

      if(!p_chosen &&  w_chosen &&  t_chosen){
        if(questions) fprintf(stderr," Pink (p) noise, or to end noises (e) ? ");
        gets(str); sscanf(str,"%c",&noisetype);
      }

      if( p_chosen && !w_chosen &&  t_chosen){
        if(questions) fprintf(stderr," White (w) noise, or to end noises (e) ? ");
        gets(str); sscanf(str,"%c",&noisetype);
      }

      if( p_chosen &&  w_chosen && !t_chosen){
        if(questions) fprintf(stderr," Ten (t) noise, or to end noises (e) ? ");
        gets(str); sscanf(str,"%c",&noisetype);
      }

      if( p_chosen &&  w_chosen &&  t_chosen){
        if(questions) fprintf(stderr," Finished: Pink, White and Ten noises (e) ? ");
        noisetype = 'e';
      }
      
      if(noisetype == 'p') pink_noise(compfq,compdB,ncomps);
      if(noisetype == 'w') white_noise(compfq,compdB,ncomps);
      if(noisetype == 't') ten_noise(compfq,compdB,ncomps);
      if(noisetype == 'e') return;
      
  }while(1);
}
/*-----------------------------------------------------------
* To simulate a band of white noise a set of equally spaced sinusoids are used,
* for a noise spectrum level of X dB each sinusoid is set at
* X = [10*log(spacing in Hz)] dB.
* for a single sinusoid (perhaps in the middle of two bands of noise) use a
* noise band from freq-0.5 to freq+0.5 Hz with a spacing of 1 Hz and the
* required level in dB */

void white_noise( double* compfq, double* compdB,long *ncomps)
{
	long i,nbands,ncount;
	double *spacing,dB,*banddBtp,*banddB,hz,realdB;
	double *bandlowfq,*bandhighfq;
	spacing    = dvector(1,10);
	banddBtp   = dvector(1,10);
	banddB     = dvector(1,10);
	bandlowfq  = dvector(1,10);
	bandhighfq = dvector(1,10);

  w_chosen = TRUE;
  do{
		if(questions) fprintf(stderr," No. of Noise Bands [max=10] ? :  ");
		gets(str); sscanf(str,"%d",&nbands);
  } while(nbands > 10);
  for( i = 1 ; i <= nbands ; i++){
    do{
			if(questions) fprintf(stderr,"%d: Lowest Freq. of Noise Band [Hz] (>= 20)? :  ",i);
			gets(str); sscanf(str,"%lf",&bandlowfq[i]);
    } while (bandlowfq[i] < 20.0);

    do{
			if(questions) fprintf(stderr,"%d: Highest Freq. of Noise Band [Hz] (<= 18000)? :  ",i);
			gets(str); sscanf(str,"%lf",&bandhighfq[i]);
    } while (bandhighfq[i] > 18000.0 && bandlowfq[i] < bandhighfq[i]);

    spacing[i] = 1.0;
    if(bandhighfq[i] - bandlowfq[i] >= 30.0) spacing[i] = 10.0;
    if(questions) fprintf(stderr," Spacing = %.1f\n",spacing[i]);
		if(questions) fprintf(stderr,"%d: Spectrum level of noise (dB SPL)? \n",i);
		gets(str); sscanf(str,"%lf",&banddB[i]);
		banddBtp[i]=banddB[i]+10.0*log10(bandhighfq[i]-bandlowfq[i]);
  }

  for( i=1 ; i <= nbands ; i++)
	if(prt) printf("%6.1f -  %6.1f |  %4.1f %4.1f | %.1f \n",bandlowfq[i],bandhighfq[i],spacing[i],banddBtp[i],banddB[i]);
  for( i = 1 ; i <= nbands ; i++){
	ncount = 0;
    dB = 10.0*log10(spacing[i])+banddB[i];
    for( hz = (bandlowfq[i]+spacing[i]/2.0) ; hz <= (bandhighfq[i]-spacing[i]/2.0) ; hz += spacing[i]){
			ncount++;
			*ncomps = *ncomps+1;
      if(*ncomps > N_COMP) error(*ncomps);
      compfq[*ncomps] = hz;
      compdB[*ncomps] = dB;
    }
		realdB = dB + 10.0*log10((double)ncount);
		if(fabs(realdB - banddBtp[i]) > 0.1){
			fprintf(stderr," !!!! WARNING !!!!\n");
			fprintf(stderr,"Band%3d: required total power = %.2f actual = %.2f\n",i,banddBtp[i],realdB);
			fprintf(stderr,"Try using a spacing that is an integer divisor of the noise bandwidth\n");
		}
	}
  if(prt) printf("ncomps = %ld\n-------------------\n",*ncomps);
}
/*c----------------------------------------------------------c*/
void pink_noise( double* compfq, double* compdB,long *ncomps)
{
  double log_pfreq;
  double plevel, pfreq, plowHz, phighHz, spacing, hz, space_dB;

  p_chosen = TRUE;
	if(questions) fprintf(stderr," Enter the freq at which the noise spectrum level is specified [default 1000] ");
  getdouble(&pfreq);
  if(pfreq == 0.0) pfreq = 1000.0;

  if(questions) fprintf(stderr," Enter the spectrum level of the pink noise in dB at %.1f Hz\n",pfreq);
	gets(str); sscanf(str,"%lf",&plevel);

  do{
    if(questions) fprintf(stderr," Enter lower and upper freq limits of noise in Hz separated by a comma\n  (within the range 20 - 18000 Hz) ");
		gets(str); sscanf(str,"%lf ,%lf",&plowHz,&phighHz);
    if(prt)printf("pink noise: %.1f dB @ %.1f Hz from %.1f to %.1f Hz\n",plevel,pfreq,plowHz,phighHz);
	}while(plowHz < 20.0 || phighHz > 18000.0);
  spacing = 1.0;
  if(phighHz - plowHz >= 30.0) spacing = 10.0;
  log_pfreq=log10(pfreq);
  space_dB = 10.0*log10(spacing);
  for( hz = plowHz+spacing/2.0 ; hz <= phighHz-spacing/2.0 ; hz += spacing){
    *ncomps = *ncomps+1;
    if(*ncomps > N_COMP) error(*ncomps);
    compfq[*ncomps]=hz;
		compdB[*ncomps]=plevel+(log_pfreq-log10(hz))*10.0+space_dB;
    if(prt)printf(" %.2f   %.2f\n",compfq[*ncomps],compdB[*ncomps]);
  }
  if(prt) printf("ncomps = %ld\n-------------------\n",*ncomps);
}
/*----------------------------------------------------*/
void ten_noise( double* compfq, double* compdB,long *ncomps)
{
  long i,nbands;
	double *spacing, spacing_dB, *dB_per_ERB,Hz, kHz;
	double *bandlowfq, *bandhighfq;
  double erb1k, erbdB;

  t_chosen = TRUE;
  erb1k = C1 * (C2 + 1.0);
	spacing    = dvector(1,20);
	dB_per_ERB = dvector(1,20);
	bandlowfq  = dvector(1,20);
	bandhighfq = dvector(1,20);

	do{
		if(questions) fprintf(stderr," No. of TEN Noise Bands [max=20] ? :  ");
		gets(str); sscanf(str,"%d",&nbands);
  } while(nbands > 20);
  for( i = 1 ; i <= nbands ; i++){
    do{
			if(questions) fprintf(stderr,"%d: Lowest Freq. of TEN Noise Band [Hz] (>= 20)? :  ",i);
			gets(str); sscanf(str,"%lf",&bandlowfq[i]);
    } while (bandlowfq[i] < 20.0);

    do{
			if(questions) fprintf(stderr,"%d: Highest Freq. of TEN Noise Band [Hz] (<= 18000)? :  ",i);
			gets(str); sscanf(str,"%lf",&bandhighfq[i]);
    } while (bandhighfq[i] > 18000.0 && bandlowfq[i] < bandhighfq[i]);

    spacing[i] = 1.0;
    if(bandhighfq[i] - bandlowfq[i] >= 30.0) spacing[i] = 10.0;
    if(questions) fprintf(stderr," Spacing = %.1f\n",spacing[i]);
		if(questions) fprintf(stderr,"%d: Level of noise (dB/ERB)? \n",i);
		gets(str); sscanf(str,"%lf",&dB_per_ERB[i]);
  }

  for( i = 1 ; i <= nbands ; i++){
    spacing_dB = 10.0*log10(spacing[i]); // PLUS dB TO MAKE REQUIRED dB/ERB - different for every freq
    for( Hz = (bandlowfq[i]+spacing[i]/2.0) ; Hz <= (bandhighfq[i]-spacing[i]/2.0) ; Hz += spacing[i]){
      kHz = Hz/1000.0;
      *ncomps = *ncomps+1;
      if(*ncomps > N_COMP) error(*ncomps);
			erbdB = 10.0 * log10(C1 * (C2 * Hz/1000.0 + 1.0));
      compfq[*ncomps] = Hz;
      compdB[*ncomps] = spacing_dB + dB_per_ERB[i] - erbdB - 10.0 * log10(calc_K(kHz));
    }
  }
}

/*----------------------------------------------------*/
#if 0
// uen_noise() is commented out,  Universal exciting noise isn't an option at the moment

void uen_noise( double* compfq, double* compdB,long *ncomps)
{
  long i,nbands;
	double *spacing,spacing_dB,*dB_per_ERB,hz;
	double *bandlowfq,*bandhighfq;
  double erb1k, erbdB;

  t_chosen = TRUE;
  erb1k = C1 * (C2 + 1.0);
//  printf("erb1k = %6.1f Hz  = %6.1f dB\n",erb1k,10.0*log10(erb1k));
	spacing    = dvector(1,20);
	dB_per_ERB = dvector(1,20);
	bandlowfq  = dvector(1,20);
	bandhighfq = dvector(1,20);

	do{
		if(questions) fprintf(stderr," No. of Uen Noise Bands [max=20] ? :  ");
		gets(str); sscanf(str,"%d",&nbands);
  } while(nbands > 20);
  for( i = 1 ; i <= nbands ; i++){
    do{
			if(questions) fprintf(stderr,"%d: Lowest Freq. of Uen Noise Band [Hz] (>= 20)? :  ",i);
			gets(str); sscanf(str,"%lf",&bandlowfq[i]);
    } while (bandlowfq[i] < 20.0);

    do{
			if(questions) fprintf(stderr,"%d: Highest Freq. of Uen Noise Band [Hz] (<= 18000)? :  ",i);
			gets(str); sscanf(str,"%lf",&bandhighfq[i]);
    } while (bandhighfq[i] > 18000.0 && bandlowfq[i] < bandhighfq[i]);

    spacing[i] = 1.0;
    if(bandhighfq[i] - bandlowfq[i] >= 30.0) spacing[i] = 10.0;
    if(questions) fprintf(stderr," Spacing = %.1f\n",spacing[i]);
		if(questions) fprintf(stderr,"%d: Level of noise (dB/ERB)? \n",i);
		gets(str); sscanf(str,"%lf",&dB_per_ERB[i]);
  }

  for( i = 1 ; i <= nbands ; i++){
    spacing_dB = 10.0*log10(spacing[i]); // PLUS dB TO MAKE REQUIRED dB/ERB - different for every freq
    for( hz = (bandlowfq[i]+spacing[i]/2.0) ; hz <= (bandhighfq[i]-spacing[i]/2.0) ; hz += spacing[i]){
			*ncomps = *ncomps+1;
      if(*ncomps > N_COMP) error(*ncomps);
			erbdB = 10.0 * log10(C1 * (C2 * hz/1000.0 + 1.0));
      compfq[*ncomps] = hz;
      compdB[*ncomps] = spacing_dB + dB_per_ERB[i] - erbdB;
    }
  }
}
#endif
/*c----------------------------------------------------------c*/
// third.c   get in third octave input levels, 29 centre freqs from 25Hz to 16kHz

void third(double *compfq, double *compdB, long *ncomps)
{
	// third.for    generate third octaves, asking for overall level in each band.
#define N_TOB 29L
	
	long i, j, n_per_tho;
		
	double mult, *edge, *oct_dB, *sp_lvl;
  double spacing,total_int;
  double nom_freqs[] = {  25.,31.5,   40.,  50.,  63.,  80.,  100.,  125.,  160., 200.,
                         250., 315., 400., 500., 630., 800., 1000., 1250., 1600.,2000.,
                        2500.,3150.,4000.,5000.,6300.,8000.,10000.,12500.,16000.
                        };
	
	edge    = dvector(1L,(N_TOB+1));
	oct_dB  = dvector(1L,(N_TOB));
	sp_lvl  = dvector(1L,(N_TOB));
	
	
	if(questions){
		fprintf(stderr,"These %2i 1/3 octaves include centre frequencies\n",N_TOB);
		fprintf(stderr," 0.0312, 0.0625, 0.125, 0.25, 0.5, 1, 2, 4, 8 & 16 kHz\n");
	}
	
	mult =	pow(2.0,(1.0/3.0));
	edge[1] = 24.80314/pow(2.0,1.0/6.0);
	for( i = 2 ; i <= N_TOB+1 ; i++ ){
		edge[i] = edge[i-1] * mult;
		sp_lvl[i-1] = 10.0 * log10(edge[i]-edge[i-1]);
	}
  
	for( i = 1 ; i <= N_TOB ; i++ ){
        if(questions)
          if(i == 2)fprintf(stderr,"  %2i total level (dB) in 1/3 octave centred at %7.1f Hz ? ",i,nom_freqs[i-1]);
          else      fprintf(stderr,"  %2i total level (dB) in 1/3 octave centred at %5.0f Hz ? ",i,nom_freqs[i-1]);
          getdouble(&oct_dB[i]); if(oct_dB[i] == 0.0) oct_dB[i] = -100.0; // zzz
				if(prt)printf("oct_dB[%2d] (%7.1f Hz) is %6.1f dB\n",i,nom_freqs[i-1],oct_dB[i]);
	}

	n_per_tho = 10;
	for( i = 1 ; i <= N_TOB ; i++ ){
		if(oct_dB[i] < -99.99999) continue;  
		if(i > 12) n_per_tho = 20;
// make into spectrum level by taking off 1/3 octave sp_lvl[i]
// then add the required bit due to the component spacing
		
		spacing = (edge[i+1]-edge[i])/n_per_tho;
		total_int = 0.0;
		for ( j = 1 ; j <= n_per_tho ; j++ ){
			(*ncomps)++;
			compfq[*ncomps] = edge[i] + ((j-1)+0.5) * spacing;
			compdB[*ncomps] = oct_dB[i] - sp_lvl[i] + 10.0*log10(spacing);
			total_int = total_int + pow(10,(compdB[*ncomps]/10.0));
		}
	}
}

//-------------------------------------------------------------------------------
void sortfq( double* compfq, double* compdB, long ncomps) // standard sorting routine
{
double amin,temp;
long i,imin,j;

	for( i = 1 ; i <= ncomps-1 ; i++){
		imin = i;
		amin = compfq[imin];
		temp = compdB[imin];
		for( j = i + 1 ; j <= ncomps ; j++){
      if(compfq[j] < amin) {
				amin = compfq[j];
				temp = compdB[j];
				imin = j;
			}
		}
		compfq[imin] = compfq[i];
		compdB[imin] = compdB[i];
		compfq[i] = amin;
		compdB[i] = temp;
	}
}
//-------------------------------------------------------------------------------
// get_doubles.c

// getdoubles   for getting in npts doubles
void getdoubles(double *bufin, long npts)
{
char bufin_st[80], *stopstring, *pdest;
long i,j;
int comma = ',', space = ' ';

  if(npts > 1 && questions){
    fprintf(stderr,"\nEnter %ld numbers separated by spaces and/or commas, ",npts);
    fprintf(stderr," [RETURN] for all zeros\n");
	}
    else if((npts == 1) && questions)
    	fprintf(stderr,"\nEnter a number, [RETURN] for zero ");

	for ( i = 1 ; i <= npts ; i++ ) bufin[i] = 0.0;

	if(fgets(bufin_st,80,stdin) == NULL) {fprintf(stderr,"fgets error\n");exit(1);}

// if any commas in bufin_st change them to spaces for strtod
  do{
    pdest = strchr(bufin_st,comma);
    if(pdest != NULL) bufin_st[(int)(pdest-bufin_st)] = space; // change comma to space
  }while(pdest != NULL);

	stopstring = bufin_st;
  for ( i = 1 ; i <= npts ; i++ ){
		bufin[i] = strtod(stopstring,&stopstring);
    if(bufin[1] == 0.0) return;
    if(bufin[i] == 0.0) break;
  }

 // make any values after return equal to last value put in
  for ( j = i-1 ; j <= npts ; j++ ) bufin[j] = bufin[i-1];
}
//-------------------------------------------------------------------------------
void getdouble(double *fl)
{
/*char str[128];*/ /* max of 127 characters from keyboard seems to be the rule */
gets(str);*fl = atof(str);
}
/*--------------------------------------------------------*/
void getlong(long *in)
{
/*char str[128];*/ /* max of 127 characters from keyboard seems to be the rule */
gets(str);*in = atoi(str);
}
/*--------------------------------------------------------*/
/* This is the subroutine for reading the correction file. */
/* only used if a headphone correction file is requested */
void read_corr(long *n_corr,double *ex_corrHz, double *ex_corrdB, FILE *corr_fd)
{
	long i, fscanf_return, err = 0;
	fscanf(corr_fd,"%d",n_corr);

  if(*n_corr > MAX_THR){
		fprintf(stderr," more than %d points in correction file ",MAX_THR);
    exit(0);
  }

  for( i = 1 ; i <= *n_corr ; i++){
    fscanf_return = fscanf(corr_fd,"%lf, ",&ex_corrHz[i]);
    if(fscanf_return != 1) {
      err = 1;
    }
  } // reading ex_corrHz[i]

  for( i = 1 ; i <= *n_corr ; i++){
    fscanf_return = fscanf(corr_fd,"%lf, ",&ex_corrdB[i]);
    if(fscanf_return != 1) {
//      fprintf("\nProbably wrong data count in table of headphone correction file\n");LEAVE IN for DOS version
      err = 1;
    }
    if(ex_corrdB[i] > 100.0){
//      fprintf("\nProbably error in correction file, dB = %7.1f\n",ex_corrdB[i]);    LEAVE IN for DOS version
      err = 1;
    }
  } // for( i = 1: ....) reading ex_corrdB[i]

  if(err == 1){

//    fprintf(stderr,"\nError reading headphone correction file\n");                   LEAVE IN for DOS version
//    fprintf(stderr,"\nTo show table read by program add -s to command line\n\n");    LEAVE IN for DOS version

    printf("\n\n");
    printf("Error reading correction file:\n\n");
    printf("  Freq, Hz     Corr dB\n");
    printf("           n = %d\n",*n_corr);
    for( i = 1 ; i <= *n_corr ; i++) printf("%2d: %7.1f     %7.1f\n",i,ex_corrHz[i], ex_corrdB[i]);
    printf("\n");
    printf("--------------------------------\n");
    fflush(stdout);
    exit(0);
  }
}
/*-------------------------------------------------------------
* This function returns a threshold correction in dB for a given frequency
* (freqHz) in Hz using polynomial interpolation with 3 points. See Numerical
* Recipes p. 80-83.  */

double thr_corr(double freqHz, long n_thr, double *corr_hz, double *corr_dB)
{
long index;
double dy, dummy;

  locate(corr_hz, n_thr, freqHz, &index);
  if(index == 0) return(corr_dB[1]);
  if(index >= n_thr) return(corr_dB[n_thr]);
  polint(&corr_hz[index],&corr_dB[index],3,freqHz,&dummy,&dy);
  return (dummy);
}
/*-------------------------------------------------------------*/
void polint(double *xa, double *ya, long n, double x, double *y, double *dy)   /* Numerical Recipes  p90 */
{
long i,m,ns=1;
double den,dif,dift,ho,hp,w;
double *c,*d;

  dif=fabs(x-xa[1]);
  c = dvector(1,n);
  d = dvector(1,n);
  for (i=1; i<=n; i++){
    if((dift=fabs(x-xa[i])) < dif) {
      ns=i;
      dif=dift;
    }
    c[i]=ya[i];
    d[i]=ya[i];
  }
  *y=ya[ns--];
  for(m=1;m<n;m++){
    for(i=1;i<=n-m;i++){
      ho=xa[i]-x;
      hp=xa[i+m]-x;
      w=c[i+1]-d[i];
			if((den=ho-hp)==0.0) nrerror ("ERROR in routine polint");
      den=w/den;
      d[i]=hp*den;
      c[i]=ho*den;
    }
    *y += (*dy = (2*ns < (n-m) ? c[ns+1] : d[ns--]));
  }
//	free_dvector(d,1);
//	free_dvector(c,1);
}

// Numerical Recipes in C 2nd ed  Copyright
